function TextField(domId, parentView, options) {
	var domId = domId;
	var parentView = parentView;

	var element;
	var textElement;
	var scrollElement;
	var scrollMarkElement;
	var scrollMarkFillElement;

	var onUpperBoundary = null;
	var onBottomBoundary = null;
	var onFocus = null;
	var onBlur = null;

	// wysokość scrolla przy okienku
	var tfScrollHeight = (options && options.scrollHeight) ? options.scrollHeight : 0;
	
	// zmienne przechowujace parametry scrolla
	var textOffset = 0;
	var textHeight = 0;
    var currentScreen = 0;
    var screenCount = 0;

	this.init = function(options) {
        var that = this;
		options = options || {};
		element = document.getElementById(domId);
		textElement = document.getElementById(domId + '-text');
		scrollElement = document.getElementById(domId + '-scroll');
		scrollMarkElement = document.getElementById(domId + '-scroll-mark');
		scrollMarkFillElement = document.getElementById(domId + '-scroll-mark-mid');
		textElement.addEventListener('keydown', function() {
            var keyCode = event.keyCode;
            switch(keyCode) {
                case Main.tvKey.KEY_UP:
                    //setTimeout(function() { that.adjustVideoScrollBar(1) }, 0);
                    that.adjustVideoScrollBar(1);
                    break;
                case Main.tvKey.KEY_DOWN:
                    //setTimeout(function() { that.adjustVideoScrollBar(2) }, 0);
                    that.adjustVideoScrollBar(2);
                    break;
                default:
                    logger.debug('TextField nie obsługuje guzików niż up i down - przekierowanie do widoku nadrzędnego (parentView: ' + parentView);
                    var action = Main.UI.input.actionForCode(keyCode);
                    if (parentView && parentView[action + 'Action']) {
                        parentView[action + 'Action']();
                    }
            }
		}, false);

		onUpperBoundary = options.onUpperBoundary || function() {};
		onBottomBoundary = options.onBottomBoundary || function() {};
		onFocus = options.onFocus || function() {};
		onBlur = options.onBlur || function() {};
		return this;
	};

	// dynamicznie utworzyć globalną funkcję i ustawić jej wywołanie w onkeydown jako string
	this.load = function(text, callback) {
		var that = this;
		textElement.innerHTML =  text + '<a id="' + domId + '-text-anchor" href="javascript:void(0);"></a>';
        setTimeout(function() { 
            logger.debug('textfield: offsetHeight: ' + textElement.offsetHeight);
            logger.debug('textfield: scrollHeight: ' + textElement.scrollHeight);
            textOffset = textElement.offsetHeight;
            textHeight = textElement.scrollHeight;
            screenCount = Math.ceil(textHeight/textOffset);
            scrollMarkFillElement.style.height = ((screenCount > 0) ? ((tfScrollHeight / screenCount) - 10) : 0) + 'px';
            currentScreen = 0;
            that.adjustVideoScrollBar(0);
            if (callback) {
                callback();
            }
        }, 0);
	};

	this.focus = function() {
		logger.debug('TextField.focus()');
		Main.UI.input.disable();
		DOMUtil.getElement(domId + '-text-anchor').focus();
		onFocus();
	};

	this.blur = function() {
		logger.debug('TextField.blur()');
		DOMUtil.getElement(domId + '-text-anchor').blur();
		Main.UI.input.enable();
		onBlur();
	};

	this.hasScroll = function() {
        logger.debug('hasScroll: textHeight: ' + textHeight + ', textOffset: ' + textOffset);
		return (textElement && (textHeight > textOffset));
	};

    this.adjustVideoScrollBar = function(direction) {
        if (direction == 0) {
            textElement.scrollTop = 0;
        } else if (direction == 1 && currentScreen > 0) {
            currentScreen--;
        } else if (direction == 2 && currentScreen < screenCount - 1) {
            currentScreen++;
        }
        if (textHeight <= textOffset) {
            this.hideScrollBar();
        } else {
            var position = parseInt(currentScreen * (tfScrollHeight / screenCount));
            logger.debug('position: ' + position);
            textElement.scrollTop = currentScreen * textOffset;
            scrollMarkElement.style.top = position + 'px';
            this.showScrollBar();
        }
    };

    this.showScrollBar = function() {
        scrollElement.style.display = "block";
    };

    this.hideScrollBar = function() {
        scrollElement.style.display = "none";
    };

}
