/**
 * Singleton do logowania komunikatw.
 */
var Logger = (function() {
	var instance;

	function constructor(pcallback) {
		var callback = pcallback;
		var loggingLevel = -1;
		var levels = {
			DEBUG: 1,
			INFO: 2,
			WARN: 3,
			ERROR: 4,
			FATAL: 5,
		}
		return {
			LEVELS: levels,
			setLevel: function(level) {
				loggingLevel = level;
			},
			info: function(msg) {
				if (loggingLevel < levels.WARN) { 
					pcallback("INFO > " + msg);
				}
			},
			debug: function(msg) {
				if (loggingLevel < levels.INFO) { 
					pcallback("DEBUG > " + msg);
				}
			},
			warn: function(msg) {
				if (loggingLevel < levels.ERROR) { 
					pcallback("WARN > " + msg);
				}
			},
			error: function(msg) {
				if (loggingLevel < levels.FATAL) { 
					pcallback("ERROR > " + msg);
				}
			},
			fatal: function(msg) {
					pcallback("ERROR > " + msg);
			},
		};
	}

	return {
		getLogger: function(callback) {
			if (!instance) {
				instance = constructor(callback);
			}
			return instance;
		}
	};
})();

/**********************************************************
 * Przykad uycia

var logger = (function() {
	var console = document.getElementById('log_console');
	return Logger.getLogger(function(msg) {
		console.innerHTML = msg + "\n" + console.innerHTML;
	});
})();
logger.setLevel(logger.LEVELS.WARN);
logger.debug("debug message");
logger.info("info message");
logger.warn("warn message");
logger.error("error message");

**/
