var MenuView = clone(View);
MenuView.init = function(name, options) {
	this._init(name, options);
	this.list = new List(this.name + '-list').init('item', {
		onUnload: function(e) {
			Main.UI.put(e, '');
			DOMUtil.hide(e);
		},
		onLoad: function(e, d) { 
			Main.UI.put(e, d.title); 
			DOMUtil.show(e);
		},
		onFocus: function(e, d) {
			FX.Menu.onButtonFocus(e, d);
		},
		onBlur: function(e, d) {
			FX.Menu.onButtonBlur(e, d);
		},
		onOverflow: function(up, down) {
			FX.Menu.onOverflowTop('menu-list-overflow-up', up);
			FX.Menu.onOverflowBottom('menu-list-overflow-down', down);
		},
        maxElementsSize: 8,
	});
	return this;
};

MenuView.show = function() {};
MenuView.hide = function() {};

MenuView.parse = function(xml) {
	var responseDoc = xml.documentElement, data = [], itemElements, i;
	if (responseDoc) {
		itemElements = responseDoc.getElementsByTagName("object");
		for (i = 0; i < itemElements.length; i++) {
			logger.debug('sparsowany object id: ' + itemElements[i].getAttribute('id'));
			data.push({
				id: itemElements[i].getAttribute('id'), 
				url: itemElements[i].getAttribute('url'), 
				view: itemElements[i].getAttribute('view'), 
				title: DOMUtil.getChildText(itemElements[i].getElementsByTagName('title'), ''),
			});
		}
		this.list.load(data, 0);
	} else {
		Main.UI.error('Nie powiodło się pobranie danych.');
	}
	return this;
};

MenuView.getCurrent = function() {
	return this.list.getCurrent();
};

MenuView.downAction = function() {
	this.list.next();
	this.loadSubview();
	return this;
};

MenuView.upAction = function() {
	this.list.prev();
	this.loadSubview();
	return this;
};

MenuView.loadSubview = function(callback) {
	var tmp = this.list.getCurrent();
	logger.debug('tmp: ' + tmp);
	if (tmp != null) { 
        tmp.data.allowedActions = {up: true, down: true};
        XHRUtil.cancel();
		Main.loadView(this, tmp.data, callback);
	}
	return this;
};

MenuView.select = function() {
	var tmp = this.list.getCurrent();
	this.loadSubview(function() {
		Main.VIEWS[tmp.data.view].focus();
	});
	return this;
};

MenuView.rightAction = function() {
	this.select();
};

MenuView.enterAction = function() {
	this.select();
};

MenuView.loadHelp = function() {
	FX.Footer.load('move', 'enter');
};

MenuView.returnAction = function() {
	Main.returnApp();
};
