var ProgramView = clone(View);
ProgramView.init = function(name, options) {
	this._init(name, options);
	this.titleElement = DOMUtil.getElement(this.name + '-title'); 
	this.currentComponent = null;

	var pv = this;

	this.grid = new Grid(this.name + '-video-grid', 4, 2, {scrollHeight: 359}).init('item', {
		onUnload: function(e) {
			FX.Grid.emptyElement(e);
		},
		onLoad: function(e, d) { 
			FX.Grid.fillElement(e, d);
		},
		onFocus: function(e, d) {
			FX.Grid.elementFocus(e, d);
			pv.loadHelp();
		},
		onBlur: function(e, d) {
			FX.Grid.elementBlur(e, d);
		},
	});
};

ProgramView.parse = function(xml) {
	var responseDoc = xml.documentElement;
	var data = [], temElements, ie, i;
	var title, description, tmp;
	if (responseDoc) {
		itemElements = responseDoc.getElementsByTagName("object");
		for (i = 0; i < itemElements.length; i++) {
			ie = itemElements[i];
			if (ie.getAttribute('type') == 'website') {
				this.title = ie.getElementsByTagName('title')[0].childNodes[0].nodeValue;
				this.description = ie.getElementsByTagName('description')[0].childNodes[0].nodeValue;
			} else {
				logger.debug('sparsowany object id: ' + itemElements[i].getAttribute('id'));
				try {
				   tmp = {	
					id: itemElements[i].getAttribute('id'), 
					url: itemElements[i].getAttribute('url'), 
					view: itemElements[i].getAttribute('view'), 
					title: DOMUtil.getChildText(itemElements[i].getElementsByTagName('title'), ''),
					msg: DOMUtil.getChildText(itemElements[i].getElementsByTagName('msg'), ''),
					img_src: DOMUtil.getChildAttribute(itemElements[i].getElementsByTagName('img'), 'src', ''),
					};
                   logger.debug('->msg: ' + DOMUtil.getChildText(itemElements[i].getElementsByTagName('msg'), ''));
                           data.push(tmp);
				} catch (err) {
					logger.error('ProgramView.parse(): ' + err);
				}
			}
		}
		Main.UI.put(this.titleElement, this.title);
		this.grid.load(data, -1);
	} else {
		Main.UI.dialog.error('Nie powiodło się pobranie danych.');
	}
	return this;
};

ProgramView._focus = function() {
	this.currentComponent = this.grid;
	this.currentComponent.focus();
};

ProgramView.loadHelp = function() {
	var fav = 'fav_serie_' + ((Main.Storage.Programs.get(this.data.id)) ? 'remove' : 'add'); 
	var fav_video = '';
	if (this.currentComponent == this.grid) {
	   var tmp = this.currentComponent.getCurrent();
	   if (tmp != null) {
		 fav_video = 'fav_' + ((Main.Storage.Video.get(tmp.data.id)) ? 'remove_hint' : 'add_hint'); 
	   }
	}
	FX.Footer.load(fav, fav_video, 'move', 'enter', 'ret');
};

ProgramView.greenAction = function() {
	if (Main.Storage.Programs.get(this.data.id)) {
		Main.Storage.Programs.remove(this.data);
	} else {
		Main.Storage.Programs.add(this.data);
	}
	FavoritesView.reload();
	ProgramView.loadHelp();
};

ProgramView.blueAction = function() {
	if (this.currentComponent == this.grid) {
		var tmp = this.currentComponent.getCurrent();
		if (tmp) {
			if (Main.Storage.Video.get(tmp.data.id)) {
				Main.Storage.Video.remove(tmp.data);
			} else {
				Main.Storage.Video.add(tmp.data);
			}
			FavoritesView.reload();
			ProgramView.loadHelp();
		}
	}
};

ProgramView.getCurrent = function() {
	var current = null;
	if (this.currentComponent == this.grid) {
		current = this.grid ? this.grid.getCurrent() : null;
	}
	return current;
};

ProgramView.leftAction = function() {
	if (this.currentComponent['prev']) {
		this.currentComponent.prev();
	}
};

ProgramView.rightAction = function() {
	if (this.currentComponent['next']) {
		this.currentComponent.next();
	}
};

ProgramView.upAction = function() {
	if (this.currentComponent['up']) {
		this.currentComponent.up();
	}
};

ProgramView.downAction = function() {
	if (this.currentComponent['down']) {
		this.currentComponent.down();
	}
};

ProgramView.blur = function() {
	this.grid.blur();
	this.grid.reset(-1);
	this._blur();
};

ProgramView.returnAction = function() {
	this.blur();
};
