var ProgramsView = clone(View);
ProgramsView.init = function(name, options) {
	this._init(name, options);
	var tv = this;
	this.grid = new Grid(this.name + '-grid', 4, 2, {scrollHeight: 359}).init('item', {
		onUnload: function(e) {
			FX.Grid.emptyElement(e);
		},
		onLoad: function(e, d) { 
			FX.Grid.fillElement(e, d);
		},
		onFocus: function(e, d) {
			FX.Grid.elementFocus(e, d);
		},
		onBlur: function(e, d) {
			FX.Grid.elementBlur(e, d);
		},
		onLeftBoundary: function() {
			tv.blur();
		},
	});
};

ProgramsView.parse = function(xml) {
	var data = [];
	var responseDoc = xml.documentElement;
	if (responseDoc) {
		var itemElements = responseDoc.getElementsByTagName("object");
		for (var i = 0; i < itemElements.length; i++) {
			logger.debug('sparsowany object id: ' + itemElements[i].getAttribute('id'));
			data.push({
				id: itemElements[i].getAttribute('id'), 
				url: itemElements[i].getAttribute('url'), 
				view: itemElements[i].getAttribute('view'), 
				title: DOMUtil.getChildText(itemElements[i].getElementsByTagName('title'), ''),
				img_src: DOMUtil.getChildAttribute(itemElements[i].getElementsByTagName('img'), 'src', ''),
			});
		}
		this.grid.load(data, -1);
	} else {
		Main.UI.dialog.error('Nie powiodło się pobranie danych.');
	}
	return this;
};

ProgramsView.getCurrent = function() {
	return this.grid ? this.grid.getCurrent() : null;
};

ProgramsView.leftAction = function() {
	this.grid.left();
};

ProgramsView.rightAction = function() {
	this.grid.right();
};

ProgramsView.upAction = function() {
	this.grid.up();
};

ProgramsView.downAction = function() {
	this.grid.down();
};

ProgramsView.returnAction = function() {
	this.blur();
};

ProgramsView._focus = function() {
	logger.debug('ProgramsView._focus');
	this.grid.focus();
};

ProgramsView.blur = function() {
    this.grid.blur();
	this.grid.reset(-1);
	this._blur();
};

ProgramsView.loadHelp = function() {
	FX.Footer.load('move', 'enter', 'ret');
};

